* gcc_release (build_sources): Create/update the LAST_UPDATED file
[official-gcc.git] / maintainer-scripts / gcc_release
blob6a5fd86d7ddb792e237b15f0d9c32349718887ab
1 #! /bin/sh
3 ########################################################################
5 # File: gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date: 2001-05-25
9 # Contents:
10 # Script to create a GCC release.
12 # Copyright (c) 2001, 2002 Free Software Foundation.
14 # This file is part of GCC.
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24 # GNU General Public License for more details.
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING. If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
31 ########################################################################
33 ########################################################################
34 # Notes
35 ########################################################################
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
40 # gcc_release -r 3.0.2
42 # This script will automatically use the head of the release branch
43 # to generate the release.
45 ########################################################################
46 # Functions
47 ########################################################################
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
52 error() {
53 echo "gcc_release: error: $1"
54 exit 1
57 # Issue the informational message given by $1.
59 inform() {
60 echo "gcc_release: $1"
63 # Issue a usage message explaining how to use this script.
65 usage() {
66 cat <<EOF
67 gcc_release -r release [-f] [further options]
68 gcc_release -s name:cvsbranch [further options]
70 Options:
72 -r release Version of the form X.Y or X.Y.Z.
73 -s name:cvsbranch Create a snapshot, not a real release.
75 -d destination Local working directory where we will build the release
76 (default=${HOME}).
77 -f Create a final release (and update ChangeLogs,...).
78 -l Indicate that we are running on gcc.gnu.org.
79 -p previous-tarball Location of a previous tarball (to generate diff files).
80 -t tag Tag to mark the release in CVS.
81 -u username Username for upload operations.
82 EOF
83 exit 1
86 # Change to the directory given by $1.
88 changedir() {
89 cd $1 || \
90 error "Could not change directory to $1"
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree. Return another name for that directory, relative
95 # to the working directory.
97 adjust_dirs() {
98 for x in $@; do
99 echo `basename ${SOURCE_DIRECTORY}`/$x
100 done
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
106 build_sources() {
107 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108 if [ -r ${WORKING_DIRECTORY} ]; then
109 error "\`${WORKING_DIRECTORY}' already exists"
111 # Create the WORKING_DIRECTORY.
112 mkdir "${WORKING_DIRECTORY}" \
113 || error "Could not create \`${WORKING_DIRECTORY}'"
114 changedir "${WORKING_DIRECTORY}"
116 # If this is a final release, make sure that the ChangeLogs
117 # and version strings are updated.
118 if [ ${FINAL} -ne 0 ]; then
119 inform "Updating ChangeLogs and version files"
121 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122 -r ${CVSBRANCH} gcc || \
123 error "Could not check out release sources"
124 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125 # Update this ChangeLog file only if it does not yet contain the
126 # entry we are going to add. (This is a safety net for repeated
127 # runs of this script for the same release.)
128 if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then
129 cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE} Release Manager
132 * GCC ${RELEASE} released.
135 mv ${x}.new ${x} || \
136 error "Could not update ${x}"
137 (changedir `dirname ${x}` && \
138 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139 error "Could not commit ${x}"
141 done
143 # Update `gcc/version.c'.
144 for x in gcc/version.c; do
145 y=`basename ${x}`
146 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147 sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148 mv ${y}.new ${y} && \
149 ${CVS} ci -m 'Update version' ${y}) || \
150 error "Could not update ${x}"
151 done
153 # Make sure we tag the sources for a final release.
154 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
156 rm -rf ${SOURCE_DIRECTORY}
159 # Tag the sources.
160 if [ -n "${TAG}" ]; then
161 inform "Tagging sources as ${TAG}"
162 ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
163 error "Could not tag sources"
164 EXPORTTAG="-r${TAG}"
165 EXPORTDATE=""
166 else
167 if [ ${CVSBRANCH} != "HEAD" ]; then
168 EXPORTTAG="-r${CVSBRANCH}"
169 else
170 # HEAD is the default branch, no need to specify it.
171 EXPORTTAG=""
173 EXPORTDATE="-D`date -u +"%Y-%m-%d %H:%M"` UTC"
176 # Export the current sources.
177 inform "Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
179 if [ -z "${EXPORTTAG}" ]; then
180 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
181 "${EXPORTDATE}" gcc || \
182 error "Could not retrieve sources"
183 elif [ -z "${EXPORTDATE}" ]; then
184 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
185 "${EXPORTTAG}" gcc || \
186 error "Could not retrieve sources"
187 else
188 error "Cannot specify -r and -D at the same time"
191 # Run gcc_update on them to set up the timestamps nicely, and (re)write
192 # the LAST_UPDATED file containing the CVS tag/date used.
193 changedir "gcc-${RELEASE}"
194 contrib/gcc_update --touch
195 echo "Obtained from CVS: ${EXPORTTAG} ${EXPORTDATE}" > LAST_UPDATED
197 # Obtain some documentation files from the wwwdocs module.
198 inform "Retrieving HTML documentation"
199 changedir "${WORKING_DIRECTORY}"
200 for x in bugs faq; do
201 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
202 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
203 ${SOURCE_DIRECTORY}) || \
204 error "Could not retrieve ${x}.html"
205 done
207 inform "Generating plain-text documentation from HTML"
208 changedir "${SOURCE_DIRECTORY}"
209 for file in *.html; do
210 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
211 (${ENV} TERM=vt100 lynx -dump $file \
212 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
213 > $newfile) || \
214 error "Could not generate text-only version of ${file}"
215 done
217 # For a prerelease or real release, we need to generate additional
218 # files not present in CVS.
219 changedir "${SOURCE_DIRECTORY}"
220 if [ $SNAPSHOT -ne 1 ]; then
221 # Generate the documentation.
222 inform "Building install docs"
223 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
224 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
225 export SOURCEDIR
226 export DESTDIR
227 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
229 # Regenerate the NEWS file.
230 contrib/gennews > gcc/NEWS || \
231 error "Could not regenerate NEWS files"
233 # Now, we must build the compiler in order to create any generated
234 # files that are supposed to go in the source directory. This is
235 # also a good sanity check to make sure that the release builds
236 # on at least one platform.
237 inform "Building compiler"
238 OBJECT_DIRECTORY=../objdir
239 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
240 error "Could not rebuild GCC"
242 # Regenerate the Fotran NEWS and BUGS files.
243 (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
244 error "Could not regenerate Fortran NEWS and BUGS files"
247 # Move message catalogs to source directory.
248 mv ../objdir/gcc/po/*.gmo gcc/po/
250 # Create a `.brik' file to use for checking the validity of the
251 # release.
252 changedir "${SOURCE_DIRECTORY}"
253 BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
254 ((find . -type f | sort > $BRIK_FILE) && \
255 brik -Gb -f ${BRIK_FILE} > .brik && \
256 rm ${BRIK_FILE}) || \
257 error "Could not compute brik checksum"
260 # Buid a single tarfile. The first argument is the name of the name
261 # of the tarfile to build, without any suffixes. They will be added
262 # automatically. The rest of the arguments are the files or
263 # directories to include.
265 build_tarfile() {
266 # Get the name of the destination tar file.
267 TARFILE="$1.tar.bz2"
268 shift
270 # Build the tar file itself.
271 (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
272 error "Could not build tarfile"
273 FILE_LIST="${FILE_LIST} ${TARFILE}"
276 # Build the various tar files for the release.
278 build_tarfiles() {
279 inform "Building tarfiles"
281 changedir "${WORKING_DIRECTORY}"
283 # The GNU Coding Standards specify that all files should
284 # world readable.
285 chmod -R a+r ${SOURCE_DIRECTORY}
286 # And that all directories have mode 777.
287 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
289 # Build one huge tarfile for the entire distribution.
290 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
292 # Now, build one for each of the languages.
293 build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
294 build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
295 build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
296 build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
297 build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
298 build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
300 # The core is everything else.
301 EXCLUDES=""
302 for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
303 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
304 EXCLUDES="${EXCLUDES} --exclude $x"
305 done
306 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
307 `basename ${SOURCE_DIRECTORY}`
310 # Build .gz files.
311 build_gzip() {
312 for f in ${FILE_LIST}; do
313 target=${f%.bz2}.gz
314 (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
315 done
318 # Build diffs against an old release.
319 build_diffs() {
320 old_dir=${1%/*}
321 old_file=${1##*/}
322 old_vers=${old_file%.tar.bz2}
323 old_vers=${old_vers#gcc-}
324 inform "Building diffs against version $old_vers"
325 for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
326 old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
327 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
328 if [ ! -e $old_tar ]; then
329 inform "$old_tar not found; not generating diff file"
330 elif [ ! -e $new_tar ]; then
331 inform "$new_tar not found; not generating diff file"
332 else
333 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
334 ${f}-${old_vers}-${RELEASE}.diff.bz2
336 done
339 # Build an individual diff.
340 build_diff() {
341 changedir "${WORKING_DIRECTORY}"
342 tmpdir=gccdiff.$$
343 mkdir $tmpdir || error "Could not create directory $tmpdir"
344 changedir $tmpdir
345 (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
346 (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
347 ${DIFF} $2 $4 > ../${5%.bz2}
348 if [ $? -eq 2 ]; then
349 error "Trouble making diffs from $1 to $3"
351 ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
352 changedir ..
353 rm -rf $tmpdir
354 FILE_LIST="${FILE_LIST} $5"
357 # Upload the files to the FTP server.
358 upload_files() {
359 inform "Uploading files"
361 changedir "${WORKING_DIRECTORY}"
363 # Make sure the directory exists on the server.
364 if [ $LOCAL -eq 0 ]; then
365 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
366 mkdir -p "${FTP_PATH}/diffs"
367 UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
368 else
369 mkdir -p "${FTP_PATH}/diffs" \
370 || error "Could not create \`${FTP_PATH}'"
371 UPLOAD_PATH=${FTP_PATH}
374 # Then copy files to their respective (sub)directories.
375 for x in gcc*.gz gcc*.bz2; do
376 if [ -e ${x} ]; then
377 # Make sure the file will be readable on the server.
378 chmod a+r ${x}
379 # Copy it.
380 case ${x} in
381 *.diff.*)
382 SUBDIR="diffs/";
385 SUBDIR="";
386 esac
387 ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
388 || error "Could not upload ${x}"
390 done
393 # Announce a snapshot, both on the web and via mail.
394 announce_snapshot() {
395 inform "Updating links and READMEs on the FTP server"
397 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
398 cd ~ftp/pub/gcc/snapshots
399 sed -e "s%@DATE@%$DATE%g" \
400 -e "s%@LAST_DATE@%$LAST_DATE%g" \
401 -e "s%@BRANCH@%${BRANCH}%g" \
402 -e "s%@RELEASE@%${RELEASE}%g" \
403 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
404 mv $$ ${RELEASE}/README
405 sed -e "s%@DATE@%$DATE%g" \
406 -e "s%@LAST_DATE@%$LAST_DATE%g" \
407 -e "s%@BRANCH@%${BRANCH}%g" \
408 -e "s%@RELEASE@%${RELEASE}%g" \
409 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
410 mv $$ ${RELEASE}/index.html
412 touch LATEST-IS-${BRANCH}-${DATE}
413 rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
415 inform "Sending mail"
417 export QMAILHOST=gcc.gnu.org
418 mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/${RELEASE}/README
421 ########################################################################
422 # Initialization
423 ########################################################################
425 # Today's date.
426 DATE=`date "+%Y%m%d"`
427 LONG_DATE=`date "+%Y-%m-%d"`
429 # The CVS server containing the GCC repository.
430 CVS_SERVER="gcc.gnu.org"
431 # The path to the repository on that server.
432 CVS_REPOSITORY="/cvs/gcc"
433 # The CVS protocol to use.
434 CVS_PROTOCOL="ext"
435 # The username to use when connecting to the server.
436 CVS_USERNAME="${USER}"
438 # The machine to which files will be uploaded.
439 GCC_HOSTNAME="gcc.gnu.org"
440 # The name of the account on the machine to which files are uploaded.
441 GCC_USERNAME="gccadmin"
442 # The directory in which the files will be placed.
443 FTP_PATH="~ftp/pub/gcc"
445 # The major number for the release. For release `3.0.2' this would be
446 # `3'
447 RELEASE_MAJOR=""
448 # The minor number for the release. For release `3.0.2' this would be
449 # `0'.
450 RELEASE_MINOR=""
451 # The revision number for the release. For release `3.0.2' this would
452 # be `2'.
453 RELEASE_REVISION=""
454 # The complete name of the release.
455 RELEASE=""
457 # The name of the branch from which the release should be made, in a
458 # user-friendly form.
459 BRANCH=""
461 # The name of the branch from which the release should be made, as used
462 # for our version control system.
463 CVSBRANCH=""
465 # The tag to apply to the sources used for the release.
466 TAG=""
468 # The old tarballs from which to generate diffs.
469 OLD_TARS=""
471 # The directory that will be used to construct the release. The
472 # release itself will be placed in a subdirectory of this diretory.
473 DESTINATION=${HOME}
474 # The subdirectory.
475 WORKING_DIRECTORY=""
476 # The directory that will contain the GCC sources.
477 SOURCE_DIRECTORY=""
479 # The directories that should be part of the various language-specific
480 # tar files. These are all relative to the top of the source tree.
481 ADA_DIRS="gcc/ada"
482 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
483 FORTRAN_DIRS="gcc/f libf2c"
484 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
485 OBJECTIVEC_DIRS="gcc/objc libobjc"
486 TESTSUITE_DIRS="gcc/testsuite"
488 # Non-zero if this is the final release, rather than a prerelease.
489 FINAL=0
491 # Non-zero if we are building a snapshot, and don't build gcc or
492 # include generated files.
493 SNAPSHOT=0
495 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
496 # and copy directly to the FTP directory.
497 LOCAL=0
499 # Major operation modes.
500 MODE_GZIP=0
501 MODE_DIFFS=0
502 MODE_SOURCES=0
503 MODE_TARFILES=0
504 MODE_UPLOAD=0
506 # List of archive files generated; used to create .gz files from .bz2.
507 FILE_LIST=""
509 # Programs we use.
511 BZIP2="${BZIP2:-bzip2}"
512 CVS="${CVS:-cvs -f -Q -z9}"
513 DIFF="${DIFF:-diff -Nrc3pad}"
514 ENV="${ENV:-env}"
515 GZIP="${GZIP:-gzip --best}"
516 SCP="${SCP:-scp -p}"
517 SSH="${SSH:-ssh}"
518 TAR="${TAR:-tar}"
520 ########################################################################
521 # Command Line Processing
522 ########################################################################
524 # Parse the options.
525 while getopts "d:fr:u:t:p:s:l" ARG; do
526 case $ARG in
527 d) DESTINATION="${OPTARG}";;
528 r) RELEASE="${OPTARG}";;
529 t) TAG="${OPTARG}";;
530 u) CVS_USERNAME="${OPTARG}";;
531 f) FINAL=1;;
532 s) SNAPSHOT=1
533 BRANCH=${OPTARG%:*}
534 CVSBRANCH=${OPTARG#*:}
536 l) LOCAL=1
537 SCP=cp
538 FTP_PATH=~ftp/pub/gcc
539 PATH=~:/usr/local/bin:$PATH;;
540 p) OLD_TARS="${OLD_TARS} ${OPTARG}"
541 if [ -d ${OPTARG} ]; then
542 error "-p argument must name a tarball"
543 fi;;
544 \?) usage;;
545 esac
546 done
547 shift `expr ${OPTIND} - 1`
549 # Handle the major modes.
550 while [ $# -ne 0 ]; do
551 case $1 in
552 diffs) MODE_DIFFS=1;;
553 gzip) MODE_GZIP=1;;
554 sources) MODE_SOURCES=1;;
555 tarfiles) MODE_TARFILES=1;;
556 upload) MODE_UPLOAD=1;;
557 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
558 if [ $SNAPSHOT -ne 1 ]; then
559 # Only for releases and pre-releases.
560 MODE_GZIP=1;
563 *) error "Unknown mode $1";;
564 esac
565 shift
566 done
568 # Perform consistency checking.
569 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
570 error "No username specified"
573 if [ ! -d ${DESTINATION} ]; then
574 error "\`${DESTINATION}' is not a directory"
577 if [ $SNAPSHOT -eq 0 ]; then
578 if [ -z ${RELEASE} ]; then
579 error "No release number specified"
582 # Compute the major and minor release numbers.
583 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
584 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
585 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
587 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
588 error "Release number \`${RELEASE}' is invalid"
591 # Compute the full name of the release.
592 if [ -z "${RELEASE_REVISION}" ]; then
593 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
594 else
595 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
598 # Compute the name of the branch, which is based solely on the major
599 # and minor release numbers.
600 CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
602 # If this is not a final release, set various parameters acordingly.
603 if [ ${FINAL} -ne 1 ]; then
604 RELEASE="${RELEASE}-${DATE}"
605 FTP_PATH="${FTP_PATH}/prerelease-${RELEASE}/"
606 else
607 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
609 else
610 RELEASE=${BRANCH}-${DATE}
611 FTP_PATH="${FTP_PATH}/snapshots/${RELEASE}"
612 if [ ${CVSBRANCH} != "HEAD" ]; then
613 TAG=gcc-ss-`echo ${RELEASE} | tr '.' '_'`
616 # Building locally on gcc.gnu.org, we know what the last snapshot date
617 # was.
618 if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ]; then
619 LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
620 LAST_DIR=~ftp/pub/gcc/snapshots/${BRANCH}-${LAST_DATE}
621 OLD_TARS=${LAST_DIR}/gcc-${BRANCH}-${LAST_DATE}.tar.bz2
625 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
626 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
627 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
629 # Recompute the names of all the language-specific directories,
630 # relative to the WORKING_DIRECTORY.
631 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
632 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
633 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
634 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
635 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
636 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
638 # Set up CVSROOT.
639 if [ $LOCAL -eq 0 ]; then
640 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
641 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
642 else
643 CVSROOT="${CVS_REPOSITORY}"
645 export CVSROOT
647 ########################################################################
648 # Main Program
649 ########################################################################
651 # Set the timezone to UTC
652 TZ="UTC0"
653 export TZ
655 # Build the source directory.
657 if [ $MODE_SOURCES -ne 0 ]; then
658 build_sources
661 # Build the tar files.
663 if [ $MODE_TARFILES -ne 0 ]; then
664 build_tarfiles
667 # Build diffs
669 if [ $MODE_DIFFS -ne 0 ]; then
670 # Possibly build diffs.
671 if [ -n "$OLD_TARS" ]; then
672 for old_tar in $OLD_TARS; do
673 build_diffs $old_tar
674 done
678 # Build gzip files
679 if [ $MODE_GZIP -ne 0 ]; then
680 build_gzip
683 # Upload them to the FTP server.
685 if [ $MODE_UPLOAD -ne 0 ]; then
686 upload_files
688 # For snapshots, make some further updates.
689 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
690 announce_snapshot
692 # Update snapshot date file.
693 changedir ~
694 echo $DATE > .snapshot_date-${BRANCH}
696 # Remove working directory
697 rm -rf ${WORKING_DIRECTORY}